Subject: [netmod] YANG1.1 issue: remove the advertisement of conformance information in NETCONF hello message

From: [email-masked]
Date: Wed, 7 May 2014 16:06:33 +0800

Hi all,

     In section 5.6.4, RFC6020, advertisement of YANG module conformance 
information MUST be implemented in hello message by NETCONF server.
I think it's out of scope of YANG. YANG only can define what the 
conformance is, but can not define how these conformance are advertised, 
it's 
operation protocol(e.g NETCONF)'s job.
     In fact, advertisement of data modules conformance information in 
hello message have caused a lot of trouble to NETCONF.
1. too big hello message.
2. how to advertise NOT YANG schema's conformance.
3. Data model information is a capability of operation protocol? I think 
it's not.
4. it's conflict with NETCONF's capabilities exchange.
   For example,NETCONF has own YANG module,it defined netconf's 
capablities as features. So, it will be advertised in hello message.
   But these capabilities have been in hello message.
   For example:
   <hello xmlns="urn:ietf:params:xml:ns:netconf:base:1.0">
     <capabilities>
       <capability>
         urn:ietf:params:netconf:base:1.1
       </capability>
       <capability>
         urn:ietf:params:netconf:capability:writable-running:1.0
       </capability>
       <capability>
         urn:ietf:params:netconf:capability:candidate:1.0
       </capability>
       <capability>
 
urn:ietf:params:xml:ns:netconf:base:1.0?module=ietf-netconf&features=writable-running,candidate
       </capability>
     </capabilities>
     <session-id>4</session-id>
   </hello>
/frank

Solution:
        remove the advertisement of YANG conformance in NETCONF hello 
message. NETCONF can decide how advertise these information by self.
--------------------------------------------------------
ZTE Information Security Notice: The information contained in this mail (and any attachment transmitted herewith) is privileged and confidential and is intended for the exclusive use of the addressee(s).  If you are not an intended recipient, any disclosure, reproduction, distribution or other dissemination or use of the information contained is strictly prohibited.  If you have received this mail in error, please delete it and notify us immediately.
--------------------------------------------------------
ZTE Information Security Notice: The information contained in this mail (and any attachment transmitted herewith) is privileged and confidential and is intended for the exclusive use of the addressee(s).  If you are not an intended recipient, any disclosure, reproduction, distribution or other dissemination or use of the information contained is strictly prohibited.  If you have received this mail in error, please delete it and notify us immediately.

---

From: Andy Bierman <[email-masked]>
Date: Wed, 7 May 2014 02:11:53 -0700

> message. NETCONF can decide how advertise these information by self.
I do not agree this is a problem.
Standardized module advertisement is important for interoperability.
Claim (1) is relative. Even 1000 modules would be way less than a mega-byte.
The largest servers have about 100 - 200 modules, nowhere near 1000.
Claim (2) is irrelevant because only YANG modules are included in YANG
module advertisement.
Non-standard proprietary modules would be advertised some other way.
Claim (3) is just wrong -- NETCONF allows a <capability> to represent
anything.
Claim (4) applies only to the ietf-netconf module.  This is the only YANG
module that
is redundant.

Andy

> _______________________________________________
> netmod mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/netmod
>
>

---

From: Martin Bjorklund <[email-masked]>
Date: Wed, 07 May 2014 11:17:35 +0200 (CEST)

> I do not agree this is a problem.

+1

> Claim (4) applies only to the ietf-netconf module.  This is the only YANG

+1 to all.

I would also add that the mapping from YANG to NETCONF needs to be
defined.  Currently it is defined in RFC 6020.  Maybe it should be
moved to a separate document, but even if it was, the advertisment of
the modules must be defined.

/martin

---

From: [email-masked]
Date: Wed, 7 May 2014 17:32:50 +0800

/frank

Martin Bjorklund <[email-masked]> 写于 2014-05-07 17:17:35:

> Martin Bjorklund <[email-masked]> 
> 2014-05-07 17:17
> 
> 收件人
> 
> [email-masked], 
> 
> 抄送
> 
> [email-masked], [email-masked]
> 
> 主题
> 
> Re: [netmod] YANG1.1 issue: remove the advertisement of conformance 
> information in NETCONF hello message
> 
> > >  urn:ietf:params:xml:ns:netconf:base:1.0?module=ietf-
> netconf&features=writable-running,candidate
> > >        </capability>
> > >      </capabilities>

I think the advertisement of YANG modules is mandatory. But how to 
advertise SHOULD be decided by operation protocol(e.g NETCONF).

I don't think this advertisement must be in hello message, it can be 
obtained by a RPC (such as get-schema-conformance).

NETCONF should provide a standard way to advertise its schema(include YANG 
and NOT YANG). This is not YANG's job.